# coding: utf-8

import pandas
import numpy
import sys
import cmath

#t@Cw肳ĂȂƏI

if len(sys.argv)<2:
	print(sys.argv[0]+'[gcp file name]')
	exit()
	
	
#CSVƃeLXg̓ǂݍ
gcpdata=pandas.read_csv(sys.argv[1])
uvwdata=pandas.read_csv(sys.argv[2], delim_whitespace=True,names=('u','v','w','r','g','b','nu','nv','nw'))


#s̒̌vZ
gcpdata['uu']=gcpdata['u']*gcpdata['u']
gcpdata['uv']=gcpdata['u']*gcpdata['v']
gcpdata['uw']=gcpdata['u']*gcpdata['w']

gcpdata['vv']=gcpdata['v']*gcpdata['v']
gcpdata['vw']=gcpdata['v']*gcpdata['w']
gcpdata['ww']=gcpdata['w']*gcpdata['w']

gcpdata['1']=1

gcpdata['ux']=gcpdata['u']*gcpdata['x']
gcpdata['vx']=gcpdata['v']*gcpdata['x']
gcpdata['wx']=gcpdata['w']*gcpdata['x']

gcpdata['uy']=gcpdata['u']*gcpdata['y']
gcpdata['vy']=gcpdata['v']*gcpdata['y']
gcpdata['wy']=gcpdata['w']*gcpdata['y']

gcpdata['uz']=gcpdata['u']*gcpdata['z']
gcpdata['vz']=gcpdata['v']*gcpdata['z']
gcpdata['wz']=gcpdata['w']*gcpdata['z']


#vZf[^Sđ
sumgcp=gcpdata.sum()


#x悭邽߁Amatrix̒0.0ɂ
#mat[0]͍s1
mat=numpy.matrix([[0.0,0.0,0.0,0.0],[0.0,0.0,0.0,0.0],[0.0,0.0,0.0,0.0],[0.0,0.0,0.0,0.0]])
mat[0]=sumgcp['uu'],sumgcp['uv'],sumgcp['uw'],sumgcp['u']
mat[1]=sumgcp['uv'],sumgcp['vv'],sumgcp['vw'],sumgcp['v']
mat[2]=sumgcp['uw'],sumgcp['vw'],sumgcp['ww'],sumgcp['w']
mat[3]=sumgcp['u'],sumgcp['v'],sumgcp['w'],sumgcp['1']


#ts
inversmat=mat.I


#Affineϊ̉Eӂ̍švZ
mat_x=numpy.matrix([[sumgcp['ux']],[sumgcp['vx']],[sumgcp['wx']],[sumgcp['x']]])
mat_y=numpy.matrix([[sumgcp['uy']],[sumgcp['vy']],[sumgcp['wy']],[sumgcp['y']]])
mat_z=numpy.matrix([[sumgcp['uz']],[sumgcp['vz']],[sumgcp['wz']],[sumgcp['z']]])


#ς̌vZiOς̏ꍇnumpy.crossj
transformation_mat_x=numpy.dot(inversmat,mat_x)
transformation_mat_y=numpy.dot(inversmat,mat_y)
transformation_mat_z=numpy.dot(inversmat,mat_z)


#_UVWXYZ̍Wnɕϊ
gcpdata['newx']=transformation_mat_x[0,0]*gcpdata['u']+transformation_mat_x[1,0]*gcpdata['v']+transformation_mat_x[2,0]*gcpdata['w']+transformation_mat_x[3,0]
gcpdata['newy']=transformation_mat_y[0,0]*gcpdata['u']+transformation_mat_y[1,0]*gcpdata['v']+transformation_mat_y[2,0]*gcpdata['w']+transformation_mat_y[3,0]
gcpdata['newz']=transformation_mat_z[0,0]*gcpdata['u']+transformation_mat_z[1,0]*gcpdata['v']+transformation_mat_z[2,0]*gcpdata['w']+transformation_mat_z[3,0]


#_UVWXYZ̍WnɕϊA_XYZƂ̍vZ
gcpdata['difx']=gcpdata['newx']-gcpdata['x']
gcpdata['dify']=gcpdata['newy']-gcpdata['y']
gcpdata['difz']=gcpdata['newz']-gcpdata['z']


#΍̃[g̓̌vZ
gcpdata['difx2']=gcpdata['difx']*gcpdata['difx']
gcpdata['dify2']=gcpdata['dify']*gcpdata['dify']
gcpdata['difz2']=gcpdata['difz']*gcpdata['difz']


#RMSĚvZ
rmsex=cmath.sqrt(gcpdata['difx2'].sum()/sumgcp['1'])
rmsey=cmath.sqrt(gcpdata['dify2'].sum()/sumgcp['1'])
rmsez=cmath.sqrt(gcpdata['difz2'].sum()/sumgcp['1'])


#UVWXYZ̍Wnɕϊ
uvwdata['newu']=transformation_mat_x[0,0]*uvwdata['u']+transformation_mat_x[1,0]*uvwdata['v']+transformation_mat_x[2,0]*uvwdata['w']+transformation_mat_x[3,0]
uvwdata['newv']=transformation_mat_y[0,0]*uvwdata['u']+transformation_mat_y[1,0]*uvwdata['v']+transformation_mat_y[2,0]*uvwdata['w']+transformation_mat_y[3,0]
uvwdata['neww']=transformation_mat_z[0,0]*uvwdata['u']+transformation_mat_z[1,0]*uvwdata['v']+transformation_mat_z[2,0]*uvwdata['w']+transformation_mat_z[3,0]


#UVWRGB̒l甽˗߂
uvwdata['rgb']=uvwdata['r']+uvwdata['g']+uvwdata['b']
uvwdata['refrectance']=uvwdata['rgb']/(256*3)


#UVW̖@xNgϊ
uvwdata['nx']=transformation_mat_x[0,0]*uvwdata['nu']+transformation_mat_x[1,0]*uvwdata['nv']+transformation_mat_x[2,0]*uvwdata['nw']+transformation_mat_x[3,0]
uvwdata['ny']=transformation_mat_y[0,0]*uvwdata['nu']+transformation_mat_y[1,0]*uvwdata['nv']+transformation_mat_y[2,0]*uvwdata['nw']+transformation_mat_y[3,0]
uvwdata['nz']=transformation_mat_z[0,0]*uvwdata['nu']+transformation_mat_z[1,0]*uvwdata['nv']+transformation_mat_z[2,0]*uvwdata['nw']+transformation_mat_z[3,0]


#ϊ@xNg̒߂
#xNg̓a
uvwdata['nx2']=uvwdata['nx']*uvwdata['nx']
uvwdata['ny2']=uvwdata['ny']*uvwdata['ny']
uvwdata['nz2']=uvwdata['nz']*uvwdata['nz']

uvwdata['total']=uvwdata['nx2']+uvwdata['ny2']+uvwdata['nz2']

#xNg̒̎Zo
uvwdata['length']=numpy.sqrt(uvwdata['total'])

#ꂼ̖@xNg@xNg̒ŊAPʖ@xNg߂
uvwdata['nix']=uvwdata['nx']/uvwdata['length']
uvwdata['niy']=uvwdata['ny']/uvwdata['length']
uvwdata['niz']=uvwdata['nz']/uvwdata['length']


#߂f[^SĂꂼꔲoAXy[X؂̃eLXgt@Cŏo

xyz_data=uvwdata[['newu','newv','neww','r','g','b','nix','niy','niz','refrectance']]
xyz_data.to_csv('xyz_data.txt',index=False,sep=' ')







